﻿//----------------------------------------------------------------------------------------
//
//	Copyright (C) 2008-2014 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files(the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions :
//	
//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.
//	
//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.
//
//----------------------------------------------------------------------------------------

# pragma once
# pragma comment (linker, "/entry:\"wWinMainCRTStartup\"")

# if(_MSC_FULL_VER < 180030723)
#  error Visual Studio 2013 update 3 以降が必要です | Visual Studio 2013 with update 3 or later is required
# endif

# ifdef _DEBUG
#  pragma comment (lib, "Siv3D_d")
# else
#  pragma comment (lib, "Siv3D")
# endif

# include "Siv3DVersion.hpp"
# include "Siv3DFwd.hpp"
# include "SivUtility.hpp"
# include "SivOptional.hpp"
# include "SivUnspecified.hpp"
# include "SivChar.hpp"
# include "SivString.hpp"
# include "SivStringView.hpp"
# include "SivCharacterSet.hpp"
# include "SivInteger.hpp"
# include "SivFloat.hpp"
# include "SivFormat.hpp"
# include "SivParse.hpp"
# include "SivAlignedAllocator.hpp"
# include "SivArray.hpp"
# include "SivGrid.hpp"
# include "SivDuration.hpp"
# include "SivDate.hpp"
# include "SivDateTime.hpp"
# include "SivTime.hpp"
# include "SivTimer.hpp"
# include "SivEventTimer.hpp"
# include "SivProfilerUtility.hpp"
# include "SivFileSystem.hpp"
# include "SivIReader.hpp"
# include "SivMemoryReader.hpp"
# include "SivBinaryReader.hpp"
# include "SivIWriter.hpp"
# include "SivMemoryWriter.hpp"
# include "SivBinaryWriter.hpp"
# include "SivTextReader.hpp"
# include "SivTextWriter.hpp"
# include "SivBase64.hpp"
# include "SivMD5.hpp"
# include "SivLogger.hpp"
# include "SivCommandLine.hpp"
# include "SivArchive.hpp"
//# include "SivFileArchive.hpp"
# include "SivRegex.hpp"
# include "SivCSVReader.hpp"
# include "SivCSVWriter.hpp"
# include "SivINIReader.hpp"
# include "SivINIWriter.hpp"
# include "SivXMLReader.hpp"
//# include "SivJSONReader.hpp"
# include "SivUID.hpp"
# include "SivMathConstants.hpp"
# include "SivColor.hpp"
# include "SivHSV.hpp"
# include "SivPointVector.hpp"
# include "SivCircular.hpp"
# include "SivLine.hpp"
# include "SivRectangle.hpp"
# include "SivCircle.hpp"
# include "SivEllipse.hpp"
# include "SivTriangle.hpp"
# include "SivQuad.hpp"
# include "SivRoundRect.hpp"
# include "SivLineString.hpp"
# include "SivPolygon.hpp"
# include "SivMultiPolygon.hpp"
# include "SivRandom.hpp"
# include "SivRandomUtility.hpp"
# include "SivMath.hpp"
# include "SivGeometry2D.hpp"
# include "SivArrow.hpp"
# include "SivNoise.hpp"
# include "SivSpline.hpp"
# include "SivSIMD.hpp"
# include "SivHalfFloat.hpp"
# include "SivImage.hpp"
# include "SivTextureFormat.hpp"
# include "SivCustomColor.hpp"
# include "SivCustomImage.hpp"
# include "SivWaveSample.hpp"
# include "SivWave.hpp"
# include "SivFFT.hpp"
# include "SivVideoWriter.hpp"
# include "SivVideoReader.hpp"
# include "SivSerial.hpp"
//# include "SivOSC.hpp"
# include "SivInternet.hpp"
# include "SivTwitter.hpp"
# include "SivMidi.hpp"
# include "SivWindow.hpp"
# include "SivMessageBox.hpp"
# include "SivSystem.hpp"
# include "SivClipboard.hpp"
# include "SivDragdrop.hpp"
# include "SivDialog.hpp"
# include "SivProfiler.hpp"
# include "SivRecorder.hpp"
# include "SivKey.hpp"
# include "SivMouse.hpp"
# include "SivTouch.hpp"
# include "SivPentablet.hpp"
# include "SivGamepad.hpp"
# include "SivXInput.hpp"
# include "SivInput.hpp"
# include "SivKinectV1.hpp"
# include "SivKinectV2.hpp"
# include "SivSound.hpp"
# include "SivBlendState.hpp"
# include "SivRasterizerState.hpp"
# include "SivDepthStencilState.hpp"
# include "SivSamplerState.hpp"
# include "SivRenderState.hpp"
# include "SivVertexShader.hpp"
# include "SivPixelShader.hpp"
# include "SivConstantBuffer.hpp"
# include "SivInputLayout.hpp"
# include "SivGraphics.hpp"
# include "SivGraphics2D.hpp"
# include "SivTexture.hpp"
# include "SivTextureRegion.hpp"
# include "SivTexturedQuad.hpp"
# include "SivDynamicTexture.hpp"
# include "SivSprite.hpp"
# include "SivKineticTypography.hpp"
# include "SivFont.hpp"
# include "SivWidgetStyle.hpp"
# include "SivIWidget.hpp"
# include "SivGUIText.hpp"
# include "SivGUINewLine.hpp"
# include "SivGUITexture.hpp"
# include "SivGUIHorizontalLine.hpp"
# include "SivGUIButton.hpp"
# include "SivGUIToggleSwitch.hpp"
# include "SivGUISlider.hpp"
# include "SivGUICheckBox.hpp"
# include "SivGUIRadioButton.hpp"
# include "SivGUITextField.hpp"
# include "SivGUITextArea.hpp"
# include "SivGUI.hpp"
# include "SivCursor.hpp"
# include "SivWebcam.hpp"
# include "SivAR.hpp"
# include "SivQuaternion.hpp"
# include "SivMat4x4.hpp"
# include "SivRay.hpp"
# include "SivTriangle3D.hpp"
# include "SivMeshData.hpp"
# include "SivMesh.hpp"
# include "SivDynamicMesh.hpp"
# include "SivTransformedMesh.hpp"
# include "SivParticle.hpp"
# include "SivPlane.hpp"
# include "SivSphere.hpp"
# include "SivBox.hpp"
# include "SivDisc.hpp"
# include "SivCylinder.hpp"
# include "SivCone.hpp"
# include "SivGeometry3D.hpp"
# include "SivModelLoader.hpp"
# include "SivModel.hpp"
# include "SivCamera.hpp"
# include "SivFog.hpp"
# include "SivLight.hpp"
# include "SivGraphics3D.hpp"
# include "SivAsset.hpp"
# include "SivSoundAsset.hpp"
# include "SivTextureAsset.hpp"		
# include "SivFontAsset.hpp"
# include "SivGUIAsset.hpp"
//# include "SivModelAsset.hpp"
# include "SivApplicationUtility.hpp"
# include "SivAddon.hpp"
# include "Siv3DDeprecated.hpp"

# ifndef NO_S3D_USING
	using namespace s3d;
# endif

#ifndef NO_MATH_USING
	using namespace s3d::Math;
#endif
