﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2014 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# include <vector>
# include "SivAlignedAllocator.hpp"

namespace s3d
{
	/// <summary>
	/// アライメントを考慮した std::vector
	/// </summary>
	template<class Type> using aligned_vector = std::vector<Type, AlignedAllocator<Type>>;

	/// <summary>
	/// アライメントを考慮した std::vector
	/// </summary>
	template<class Type, size_t Alignment = AlignmentOf<Type>::value> using Array = typename std::conditional_t<(Alignment >= 16), aligned_vector<Type>, std::vector<Type>>;
}
