﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2014 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once
# define HalfWidthSpace L' '
# define FullWidthSpace L'　'

namespace s3d
{
	inline
	Char::operator wchar_t() const
	{
		return static_cast<wchar_t>(ch);
	}

	inline
	bool Char::_get_isDigit() const
	{
		return (ch - L'0') <= (L'9'-L'0');
	}

	inline
	bool Char::_get_isLower() const
	{
		return (ch - L'a') <= (L'z' - L'a');
	}

	inline
	bool Char::_get_isUpper() const
	{
		return (ch - L'A') <= (L'Z' - L'A');
	}

	inline
	bool Char::_get_isAlpha() const
	{
		return isLower || isUpper;
	}

	inline
	bool Char::_get_isAlnum() const
	{
		return isDigit || isAlpha;
	}

	inline
	bool Char::_get_isXdigit() const
	{
		return isDigit || ((ch - L'A') <= (L'F' - L'A')) || ((ch - L'a') <= (L'f' - L'a'));
	}

	inline
	bool Char::_get_isControl() const
	{
		return (ch <= 0x1F) || ((ch - 0x7F) <= (0x9F - 0x7F));
	}

	inline
	bool Char::_get_isBlank() const
	{
		return (ch == HalfWidthSpace) || (ch == L'\t') || (ch == FullWidthSpace);
	}

	inline
	bool Char::_get_isSpace() const
	{
		return ((ch - L'\t') <= (L'\r' - L'\t')) || (ch == HalfWidthSpace) || (ch == FullWidthSpace);
	}

	inline
	bool Char::_get_isPrint() const
	{
		return !!::iswprint(static_cast<wchar_t>(ch));
	}
}

# undef HalfWidthSpace
# undef FullWidthSpace
