﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2014 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once

namespace s3d
{
	/// <summary>
	/// Perlin Noise 生成
	/// </summary>
	/// <remarks>
	/// リファレンス実装 http://mrl.nyu.edu/~perlin/noise/
	/// </remarks>
	class Noise
	{
	public:

		explicit Noise(unsigned seed = 0);

		double noise(double x) const;

		double noise(double x, double y) const;

		double noise(double x, double y, double z) const;

		double octaveNoise(double x, int octaves) const;

		double octaveNoise(double x, double y, int octaves) const;

		double octaveNoise(double x, double y, double z, int octaves) const;

	private:

		double fade(double t) const;

		double lerp(double t, double a, double b) const;

		double grad(int hash, double x, double y, double z) const;

		int p[512];
	};
}
