﻿//-----------------------------------------------
//
//	This file is part of the Siv3D Engine.
//
//	Copyright (C) 2008-2014 Ryo Suzuki
//
//	Licensed under the MIT License.
//
//-----------------------------------------------

# pragma once

namespace s3d
{
	/**
	*	@brief 波形のサンプルデータ
	*/
	union WaveSample
	{
		unsigned _left_right;

# pragma warning ( disable: 4201 )
		struct
		{
			int left : 16;
			int right : 16;
		};
# pragma warning ( default: 4201 )

		/**
		*
		*/
		WaveSample(){}

		/**
		*
		*	@param mono
		*/
		WaveSample(int mono)
			: WaveSample(mono, mono){}

		/**
		*
		*	@param _left
		*	@param _right
		*/
		WaveSample(int _left, int _right) : left(_left & 0xffFF), right(_right & 0xffFF){}

		/**
		*
		*	@param sample
		*/
		WaveSample(const WaveSample& sample) : _left_right(sample._left_right){}

		/**
		*
		*	@param sample
		*	@return
		*/
		WaveSample& operator = (const WaveSample& sample)
		{
			_left_right = sample._left_right;
			return *this;
		}

		/**
		*
		*	@param mono
		*	@return
		*/
		WaveSample& operator = (int mono)
		{
			left = right = mono;
			return *this;
		}

		WaveSample& set(int mono)
		{
			left = right = mono;

			return *this;
		}

		WaveSample& set(int _left, int _right)
		{
			left = _left;
	
			right = _right;
			
			return *this;
		}

		/**
		*
		*/
		void swapChannel()
		{
			const int tmp = left;
			left = right;
			right = tmp;
		}
	};
}
